﻿using Microsoft.AspNetCore.Mvc;
using Vezbe5i6.Models;
using Vezbe5i6.Repository;

namespace Vezbe5i6.Controllers
{
    public class CategoryController : Controller
    {
        private readonly ICategoryRepository _categoryRepository;

        public CategoryController(ICategoryRepository categoryRepository)
        {
            _categoryRepository = categoryRepository;
        }

        public IActionResult Index([FromQuery] string filter)
        {
            ViewData["filter"] = filter;
            if (string.IsNullOrEmpty(filter))
                return View(_categoryRepository.GetAll());
            else
                return View(_categoryRepository.GetWithFilter(filter));
        }
        public IActionResult Create()
        {
            return View("Edit", new Category());
        }
        public IActionResult Edit(int id)
        {
            var cat = _categoryRepository.GetSingle(id);
            if (cat == null)
                return RedirectToAction("Index");
            return View(cat);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Category category)
        {
            try
            {
                if (!ModelState.IsValid)
                    return View(category);

                _categoryRepository.Save(category);
                return RedirectToAction("Index");
            }
            catch
            {
                return View(category);
            }
        }
        public IActionResult Delete(int id)
        {
            _categoryRepository.Delete(id);
            return RedirectToAction("Index");
        }
    }
}