﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace Vezbe5i6.Models
{
    public class Product
    {
        [Required(ErrorMessage = "ProductId je obavezan")]
        public int ProductId { get; set; }

        [DisplayName("Naziv")]
        [Required(ErrorMessage = "Naziv je obavezan")]
        [MaxLength(200)]
        public string Name { get; set; } = "";

        [DisplayName("Šifra")]
        [Required(ErrorMessage = "Sifra je obavezan")]
        [MaxLength(20, ErrorMessage = "Maksimalno 20 karaktera za sifru")]
        public string Code { get; set; } = "";

        [DisplayName("Cena")]
        [Required(ErrorMessage = "Cena je obavezna")]
        [Range(0, double.PositiveInfinity, ErrorMessage = "Cena ne sme da bude manja od 0")]
        public decimal Price { get; set; }

        [DisplayName("Opis")]
        public string Description { get; set; } = "";

        [DisplayName("Kategorija")]
        [Required(ErrorMessage = "Kategorija je obavezna")]
        public Category? Category { get; set; } = new Category();

        [DisplayName("Slika")]
        public string? ImageName { get; set; }

        public string ImagePath => "/images/" + ImageName;

        public IFormFile? NewImage { set; get; }

        [DisplayName("Aktivan")]
        public bool Active { get; set; }
    }
}
