﻿using Vezbe5i6.Models;

namespace Vezbe5i6.Repository
{
    public class CategoryInMemoryRepository : ICategoryRepository
    {
        private readonly List<Category> _data = new();

        public CategoryInMemoryRepository()
        {
            _data.Add(new Category { CategoryId = 1, Name = "Tv", Code = "01", Active = true });
            _data.Add(new Category { CategoryId = 2, Name = "Bela tehnika", Code = "02", Active = true });
            _data.Add(new Category { CategoryId = 3, Name = "Racunari", Code = "03", Active = true });
            _data.Add(new Category { CategoryId = 4, Name = "Mobilni", Code = "04", Active = true });
        }

        public List<Category> GetAll()
        {
            return _data;
        }
        public List<Category> GetWithFilter(string filter)
        {
            filter = filter.ToLower();
            return _data.Where(p => p.Name.ToLower().Contains(filter) || p.Code.ToLower().Contains(filter)).ToList();
        }
        public Category? GetSingle(int categoryId)
        {
            return _data.FirstOrDefault(p => p.CategoryId == categoryId);
        }
        public void Delete(int categoryId)
        {
            _data.RemoveAll(p => p.CategoryId == categoryId);
        }
        public int Save(Category category)
        {
            if (category.CategoryId == 0)
            {
                var maxID = _data.Max(p => p.CategoryId);
                category.CategoryId = maxID + 1;
                _data.Add(category);
            }
            else
            {
                var c = _data.FirstOrDefault(p => p.CategoryId == category.CategoryId);
                if (c != null)
                    _data.Remove(c);
                _data.Add(category);
            }
            return category.CategoryId;
        }
    }
}